function F = HypergeometricPFQ(coeff1,coeff2,x)
% To calculate the hypergeometric function pFq
% coeff1 = [a1,a2,...], coeff2 = [b1,b2,...]

coeff3 = coeff1;
coeff = zeros(length(coeff2));

% check each element in coeff2, if there is same element in coeff1(3), 
% remove it in coeff3; if not, copy the element in coeff4;

k = 0;
for i=1:length(coeff2)
    check = 0;  %check whether repeat or not
    for j=1:length(coeff3)
        if coeff2(i)==coeff3(j)
            check = 1;
            coeff3(j)=[];
            break;
        end
    end
    if check == 0
        k = k + 1;
        coeff(k) = coeff2(i);
    end
end

coeff4 = coeff([1:k]);

clear coeff


% Check whether zeros in ai are more than zeros in bi
check_numerator = 0;

for i=1:length(coeff3)
    if coeff3(i) == 0
        check_numerator = 1; %truly more zeros in numerator
        break;
    end
end

% Check whether zeros or negative numbers in bi
check_denominator = 0;

for i=1:length(coeff4)
    if coeff4(i)<=0
        check_denominator = 1;
        break;
    end
end

if check_numerator == 1
    F = 1;
elseif check_denominator == 1
    F = 0;
else
    F = hypergeom(coeff3,coeff4,x);
end
    
end

