function R = MGamma(coeff1,coeff2)
% To calculate the multiplication and division of gamma function
% coeff1 = [a1,a2,...], coeff2 = [b1,b2,...]
% R = gamma(a1)*gamma(a2)*...*gamma(am)/(gamma(b1)*...*gamma(bn))

coeff3 = check_negative(coeff1);
coeff4 = check_negative(coeff2);
coeff = zeros(length(coeff4));

% check each element in coeff2, if there is same element in coeff1(3), 
% remove it in coeff3; if not, copy the element in coeff4;

k = 0;
for i=1:length(coeff4)
    check = 0;  %check whether repeat or not
    for j=1:length(coeff3)
        if coeff4(i)==coeff3(j)
            check = 1;
            coeff3(j)=[];
            break;
        end
    end
    if check == 0
        k = k + 1;
        coeff(k) = coeff4(i);
    end
end

coeff4 = coeff([1:k]);

check_denominator = 0;
for i=1:length(coeff4)
    if coeff4(i) == 0
        check_denominator = 1;  %zeros in denominator
        break;
    end
end

numerator = 1;
denominator = 1;

if check_denominator == 1
    R = 0;
else
    for i=1:length(coeff3)
        numerator = numerator * gamma(coeff3(i));
    end
    
    for j=1:length(coeff4)
        denominator = denominator * gamma(coeff4(j));
    end
    
    R = numerator / denominator;
end

end


function coeff0 = check_negative(coeff)
% Transform any negative integers in coeff into zeros.

coeff0 = coeff;

for i=1:length(coeff0)
    if (coeff0(i) < 0) && (coeff0(i) == fix(coeff0(i)))
        coeff0(i) = 0;
    end
end

end
