function b4_1 = fourth_virial1(coeffs)
%fourth virial coefficient, the second part.
%  coeffs=[\sigma,\lambda0,\lambda1,f0,f1]
    sigma = coeffs(1);
    r0 = coeffs(2);
    r1 = coeffs(3);
    f0 = coeffs(4);
    f1 = coeffs(5);

% Main coefficient
    c = -3/8 * 4 * pi * sigma^3;

    c1 = (1+f0)^4 + (f0-f1)^4*r0^3 + f1^4*r1^3;
    a1 = 4/(3*pi);
    
    c2 = -4 * (1+f0)^3 * (f0-f1);
    if r0 < 3
        a2 = 1/(4*pi) * (8-9*(1-r0/3)^3);
    else
        a2 = 2/pi;
    end
    
    c3 = -4 * (1+f0)^3 * f1;
    if r1 < 3
        a3 = 1/(4*pi) * (8-9*(1-r1/3)^3);
    else
        a3 = 2/pi;
    end
    
    c4 = -4 * (1+f0) * (f0-f1)^3;
    a4 = 3/(2*pi) * (r0^2-1/9);
    
    c5 = 4 * (f0-f1)^3 * f1;
    if r1 < 3*r0
        a5 = 1/(4*pi) * (8*r0^3 - 9*(r0-r1/3)^3);
    else
        a5 = 2/pi * r0^3;
    end
    
    c6 = -4 * (1+f0) * f1^3;
    a6 = 3/(2*pi) * (r1^2-1/9);
    
    c7 = 4 * (f0-f1) * f1^3;
    a7 = 3/(2*pi) * (r1^2-r0^2/9);
    
    c8 = 6 * (1+f0)^2 * (f0-f1)^2;
    a8 = 2/(3*pi) * (3*r0-1);
    
    c9 = 6 * (1+f0)^2 * f1^2;
    a9 = 2/(3*pi) * (3*r1-1);
    
    c10 = 6 * (f0-f1)^2 * f1^2 * r0 * r1;
    a10 = 2*r0/(3*pi*r1) * (3*r1-r0);
    
    c11 = 12 * (1+f0)^2 * (f0-f1) * f1;
    if r1 < 2+r0
        a11 = -1/(12*pi) * (8 + 6*(r0-r1)^2 + (r0-r1)^3 - 12*(r0+r1));
    else
        a11 = 2/pi * r0;
    end
    
    c12 = -12 * (1+f0) * (f0-f1)^2 * f1;
    if r1 > 2*r0+1
        a12 = 2/pi * r0^2;
    elseif r1 > 2*r0-1
        a12 = -1/(12*pi) * (8*r0^3+6*r0*(1-r1)^2+(1-r1)^3-12*r0^2*(1+r1));
    else
        a12 = -1/(6*pi) * (1+3*r1*(-4*r0+r1));
    end
    
    c13 = -12 * (1+f0) * (f0-f1) * f1^2;
    a13 = -1/(6*pi) * (-12*r0*r1 + 3*r0^2 + 1);
    
    
    b4_1 = c * (c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6+c7*a7+c8*a8 ...
        +c9*a9+c10*a10+c11*a11+c12*a12+c13*a13);
    
end
