function b4_2 = fourth_virial2_3d(coeffs)
%fourth virial coefficient, the second part.
%  coeffs=[\sigma,\lambda0,\lambda1,f0,f1]
    sigma = coeffs(1);
    r0 = coeffs(2);
    r1 = coeffs(3);
    f0 = coeffs(4);
    f1 = coeffs(5);

% Main coefficient
    c = -3/4 * 4*pi * (2*pi)^3 * sigma^(3*3);

    b4_2 = c * ((-1)*result1(r0,r1,f0,f1) + f0*result2(r0,r1,f0,f1) ...
        + f1*result3(r0,r1,f0,f1));
    %fprintf("b4_2 = %f\n",b4_2);
    
end

function res1 = result1(r0,r1,f0,f1)
% First integral, from 0 to 1
    syms y;

    c1 = (1+f0)^2;
    a1 = (1/24).*(2.*pi).^(-1/2).*((-2)+y).^2.*y.^(1/2).*(4+y);
    
    c2 = (f0-f1)^2 * r0^3;
    a2 = (1/24).*(2.*pi).^(-1/2).*r0.^(-3).*y.^(1/2).*((-2).*r0+y).^2.*(4.* ...
  r0+y);
    
    c3 = f1^2 * r1^3;
    a3 = (1/24).*(2.*pi).^(-1/2).*r1.^(-3).*y.^(1/2).*((-2).*r1+y).^2.*(4.* ...
  r1+y);
    
    c4 = -2 * (1+f0) * (f0-f1) * r0^(3/2);
    a4 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*y).^(-3/2).*((-3)+6.*r0.^2+(-3).* ...
  r0.^4+24.*y+8.*r0.^3.*y+(-6).*y.^2+(-6).*r0.^2.*y.^2+y.^4+4.*((-1) ...
  +r0).*abs(1+(-1).*r0+y).^3+(1+(-1).*r0+y).^2.*(r0.^2+(1+y).^2+(-2) ...
  .*r0.*(7+y)).*sign(1+(-1).*r0+y));
    
    c5 = -2 * (1+f0) * f1 * r1^(3/2);
    a5 = (1/48).*(2.*pi).^(-1/2).*y.*(r1.*y).^(-3/2).*((-3)+6.*r1.^2+(-3).* ...
  r1.^4+24.*y+8.*r1.^3.*y+(-6).*y.^2+(-6).*r1.^2.*y.^2+y.^4+4.*((-1) ...
  +r1).*abs(1+(-1).*r1+y).^3+(1+(-1).*r1+y).^2.*(r1.^2+(1+y).^2+(-2) ...
  .*r1.*(7+y)).*sign(1+(-1).*r1+y));
    
    c6 = 2 * (f0-f1) * f1 * r0^(3/2) * r1^(3/2);
    a6 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*r1.*y).^(-3/2).*((-3).*r0.^4+6.* ...
  r0.^2.*r1.^2+(-3).*r1.^4+24.*r0.^3.*y+8.*r1.^3.*y+(-6).*r0.^2.* ...
  y.^2+(-6).*r1.^2.*y.^2+y.^4+(-4).*(r0+(-1).*r1).*abs(r0+(-1).*r1+ ...
  y).^3+(r0+(-1).*r1+y).^2.*(r0.^2+(r1+(-1).*y).^2+2.*r0.*((-7).*r1+ ...
  y)).*sign(r0+(-1).*r1+y));
    
    res1 = int((c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,0,1);
    
    %fprintf("%f\n",res1);

end

function res2 = result2(r0,r1,f0,f1)
% Second integral, from 1 to r0
    syms y;

    c1 = (1+f0)^2;
    % if y<2
    a1 = (1/3).*(2.*pi.^(-1)).^(1/2).*y.^(1/2)+(-1/2).*(2.*pi).^(-1/2).* ...
  y.^(3/2).*(1+(-1/12).*y.^2);
    % else, a1 = 0
    
    c2 = (f0-f1)^2 * r0^3;
    a2 = (1/24).*(2.*pi).^(-1/2).*r0.^(-3).*y.^(1/2).*((-2).*r0+y).^2.*(4.* ...
  r0+y);
    
    c3 = f1^2 * r1^3;
    a3 = (1/24).*(2.*pi).^(-1/2).*r1.^(-3).*y.^(1/2).*((-2).*r1+y).^2.*(4.* ...
  r1+y);
    
    c4 = -2 * (1+f0) * (f0-f1) * r0^(3/2);
    a4 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*y).^(-3/2).*((-3)+6.*r0.^2+(-3).* ...
  r0.^4+24.*y+8.*r0.^3.*y+(-6).*y.^2+(-6).*r0.^2.*y.^2+y.^4+4.*((-1) ...
  +r0).*abs(1+(-1).*r0+y).^3+(1+(-1).*r0+y).^2.*(r0.^2+(1+y).^2+(-2) ...
  .*r0.*(7+y)).*sign(1+(-1).*r0+y));
    
    c5 = -2 * (1+f0) * f1 * r1^(3/2);
    a5 = (1/48).*(2.*pi).^(-1/2).*y.*(r1.*y).^(-3/2).*((-3)+6.*r1.^2+(-3).* ...
  r1.^4+24.*y+8.*r1.^3.*y+(-6).*y.^2+(-6).*r1.^2.*y.^2+y.^4+4.*((-1) ...
  +r1).*abs(1+(-1).*r1+y).^3+(1+(-1).*r1+y).^2.*(r1.^2+(1+y).^2+(-2) ...
  .*r1.*(7+y)).*sign(1+(-1).*r1+y));
    
    c6 = 2 * (f0-f1) * f1 * r0^(3/2) * r1^(3/2);
    a6 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*r1.*y).^(-3/2).*((-3).*r0.^4+6.* ...
  r0.^2.*r1.^2+(-3).*r1.^4+24.*r0.^3.*y+8.*r1.^3.*y+(-6).*r0.^2.* ...
  y.^2+(-6).*r1.^2.*y.^2+y.^4+(-4).*(r0+(-1).*r1).*abs(r0+(-1).*r1+ ...
  y).^3+(r0+(-1).*r1+y).^2.*(r0.^2+(r1+(-1).*y).^2+2.*r0.*((-7).*r1+ ...
  y)).*sign(r0+(-1).*r1+y));
    
    if r0 < 2
        res2 = int((c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,1,r0);
    else
        res2 = int((c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,1,2);
        res2 = res2 + int((c1*0+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,2,r0);
    end
        
    %fprintf("%f\n",res2);

end

function res3 = result3(r0,r1,f0,f1)
% Third integral, from r0 to r1
    syms y;

    c1 = (1+f0)^2;
    % if y<2
    a1 = (1/3).*(2.*pi.^(-1)).^(1/2).*y.^(1/2)+(-1/2).*(2.*pi).^(-1/2).* ...
  y.^(3/2).*(1+(-1/12).*y.^2);
    % else, a1 = 0
    
    c2 = (f0-f1)^2 * r0^3;
    a2 = (1/48).*(2.*pi).^(-1/2).*r0.^(-3).*y.^(-1/2).*((-8).*r0.*abs((-2) ...
  .*r0+y).^3+8.*r0.*abs(2.*r0+y).^3+12.*r0.^2.*((-2).*r0+y).^2.* ...
  sign(2.*r0+(-1).*y)+((-2).*r0+y).^4.*sign(2.*r0+(-1).*y)+(-24).* ...
  r0.^2.*y.^2.*sign(y)+2.*y.^4.*sign(y)+(-12).*r0.^2.*(2.*r0+y).^2.* ...
  sign(2.*r0+y)+(-1).*(2.*r0+y).^4.*sign(2.*r0+y));
    
    c3 = f1^2 * r1^3;
    a3 = (1/24).*(2.*pi).^(-1/2).*r1.^(-3).*y.^(1/2).*((-2).*r1+y).^2.*(4.* ...
  r1+y);
    
    c4 = -2 * (1+f0) * (f0-f1) * r0^(3/2);
    a4 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*y).^(-3/2).*((-4).*(1+r0).*abs(1+ ...
  r0+(-1).*y).^3+(1+r0+(-1).*y).^2.*((-3)+(-3).*r0.^2+2.*y+y.^2+2.* ...
  r0.*(3+y)+(r0.^2+(-2).*r0.*((-7)+y)+((-1)+y).^2).*sign(1+r0+(-1).* ...
  y)));
    
    c5 = -2 * (1+f0) * f1 * r1^(3/2);
    a5 = (1/48).*(2.*pi).^(-1/2).*y.*(r1.*y).^(-3/2).*((-3)+6.*r1.^2+(-3).* ...
  r1.^4+24.*y+8.*r1.^3.*y+(-6).*y.^2+(-6).*r1.^2.*y.^2+y.^4+4.*((-1) ...
  +r1).*abs(1+(-1).*r1+y).^3+(1+(-1).*r1+y).^2.*(r1.^2+(1+y).^2+(-2) ...
  .*r1.*(7+y)).*sign(1+(-1).*r1+y));
    
    c6 = 2 * (f0-f1) * f1 * r0^(3/2) * r1^(3/2);
    a6 = (1/48).*(2.*pi).^(-1/2).*y.*(r0.*r1.*y).^(-3/2).*((-3).*r0.^4+6.* ...
  r0.^2.*r1.^2+(-3).*r1.^4+24.*r0.^3.*y+8.*r1.^3.*y+(-6).*r0.^2.* ...
  y.^2+(-6).*r1.^2.*y.^2+y.^4+(-4).*(r0+(-1).*r1).*abs(r0+(-1).*r1+ ...
  y).^3+(r0+(-1).*r1+y).^2.*(r0.^2+(r1+(-1).*y).^2+2.*r0.*((-7).*r1+ ...
  y)).*sign(r0+(-1).*r1+y));
    
    if r0 < 2
        res3 = int((c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,r0,2);
        res3 = res3 + int((c1*0+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,2,r1);
    else
        res3 = int((c1*0+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6)^2*y,r0,r1);
    end
    
    %fprintf("%f\n",res3);

end