%% calculation of B3 in 3D
close all;
clear;

% coeffs = [\sigma, \lambda0, \lambda1, \epsilon0, \epsilon1]
coeffs = [1, 1.5, 4, 1, 0.025];

% Temperature
T = [linspace(0.4,0.9,80)];

h1 = zeros(1,length(T));
h2 = zeros(1,length(T));

for i=1:length(T)
    f0 = exp(coeffs(4)/T(i))-1;
    f1_1 = exp(-0/T(i))-1;
    f1_2 = exp(-coeffs(5)/T(i))-1;
    %b2 = second_virial([1,2.5,4,f0,f1]);
    %fprintf('b2 = %f\n',b2);
    h1(i)=third_virial_d([coeffs(1),coeffs(2),coeffs(3),f0,f1_1], 3);
    h2(i)=third_virial_d([coeffs(1),coeffs(2),coeffs(3),f0,f1_2], 3);
end

%% draw inset
x1 = interp1(h1(1:end),T(1:end),0);
x2 = interp1(h2(1:end),T(1:end),0);

fprintf('Tc = %f\n',x1);
fprintf('Tc = %f\n',x2);

g = zeros(1,length(T));
color = get(gca,'colororder');

set(gcf,'Position',[0 0 220 160]);


plot(T,h1, '-.', 'color', color(4,:)', 'linewidth',1.5), hold on;
plot(T,h2, 'color', color(4,:)', 'linewidth',1.5), hold on;
plot(T,g,'k--','linewidth', 1), hold on;
xlim([0.4 0.9]);
ylim([-8000 100]);
%yticks([-8000 -4000 0]);
%yticklabels({'-8e3','-4e3','0'});
symlog(gca,'y',-0.9);

xlabel('$T$','Interpreter','Latex', 'fontsize',16);
ylabel('$B_3$','Interpreter','Latex', 'fontsize',16);
%title('$B_3-T curve (\lambda_0=2.5,\lambda_1=4.0)$','Interpreter','Latex');

set(gca,'fontsize',14);
set(gca,'fontname','Times New Roman');
