%% draw B4 in 3D, Figure 2b

close all;
clear;
color = get(gca,'colororder');

% coeffs = [\sigma, \lambda0, \lambda1, \epsilon0, \epsilon1]
coeffs = [1, 1.5, 4, 1, 0];

path = "../data_B4";

filename = sprintf("%s/[1,1.5,4,1,0]/B4_1.dat", path);
fid = fopen(filename);
X1 = textscan(fid, '%f %f', 'HeaderLines', 1);
t1 = X1{1}; % temperature
h1 = X1{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0]/B4_2.dat", path);
fid = fopen(filename);
X2 = textscan(fid, '%f %f', 'HeaderLines', 1);
t2 = X2{1}; % t
h2 = X2{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0]/B4_3.dat", path);
fid = fopen(filename);
X3 = textscan(fid, '%f %f', 'HeaderLines', 1);
t3 = X3{1}; % t
h3 = X3{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0.025]/B4_1.dat", path);
fid = fopen(filename);
X4 = textscan(fid, '%f %f', 'HeaderLines', 1);
t4 = X4{1}; % t
h4 = X4{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0.025]/B4_2.dat", path);
fid = fopen(filename);
X5 = textscan(fid, '%f %f', 'HeaderLines', 1);
t5 = X5{1}; % t
h5 = X5{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0.025]/B4_3.dat", path);
fid = fopen(filename);
X6 = textscan(fid, '%f %f', 'HeaderLines', 1);
t6 = X6{1}; % t
h6 = X6{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0]/B4.dat", path);
fid = fopen(filename);
X7 = textscan(fid, '%f %f', 'HeaderLines', 1);
t7 = X7{1}; % t
h7 = X7{2}; % 
fclose(fid);

filename = sprintf("%s/[1,1.5,4,1,0.025]/B4.dat", path);
fid = fopen(filename);
X8 = textscan(fid, '%f %f', 'HeaderLines', 1);
t8 = X8{1}; % t
h8 = X8{2}; % 
fclose(fid);

plot(t1,h1, '-.', 'color', color(1,:)', 'linewidth',1.5), hold on;
plot(t4,h4, 'color', color(1,:)', 'linewidth',1.5), hold on;
plot(t2,h2, '-.', 'color', color(2,:)', 'linewidth',1.5), hold on;
plot(t5,h5, 'color', color(2,:)', 'linewidth',1.5), hold on;
plot(t3,h3, '-.', 'color', color(3,:)', 'linewidth',1.5), hold on;
plot(t6,h6, 'color', color(3,:)', 'linewidth',1.5), hold on;
plot(t7,h7, '-.', 'color', 'k', 'linewidth',1.5), hold on;
plot(t8,h8, 'color', 'k', 'linewidth',1.5), hold on;

plot(linspace(0.4,0.9,10), zeros(1,10), 'k--', 'linewidth',1), hold on;
ylim([-1e8,1e4]);

symlog(gca,'y',-0.7);
set(gca,'fontsize',14);
set(gca,'fontname','Times New Roman');

xlabel('$T$','Interpreter','Latex', 'fontsize',16);
ylabel('$B_4$','Interpreter','Latex', 'fontsize',16);
xticks([0.4 0.5 0.6 0.7 0.8 0.9]);
xlim([0.4, 0.9]);

%title('$B_4-T curve (\lambda_0=2.5,\lambda_1=4.0)$','Interpreter','Latex');
text(-0.12, 1, "(b)", 'Units','normalized', 'fontname','Times New Roman', 'FontSize',16, 'color','k');
