# Matlab codes to numerically calculate B2, B3 and B4 (first two terms)
# Matlab codes to draw Figure 2b

Calculation follows the analytical expressions described in Appendix A and Supplementary Material
Work with Matlab R2018b

Note: Due to calculation difficulty explained in Appendix A, the third term in B4 we used is calculated from Mathematica (for 1D, an example given in folder Calculation_Mathematica) and Monte Carlo Integration (recommended for 3D, codes in C language given in folder Calculation_MC)

## File description
- second_virial_d.m
B2 for arbitrary d dimension
- third_virial_d.m
B3 for arbitrary d dimension
- fourth_virial1.m
The first term of B4 in 1D
- fourth_virial1_3d.m
The first term of B4 in 3D
- fourth_virial2.m
The second term of B4 in 1D
- fourth_virial2_3d.m
The second term of B4 in 3D
- operate_1d.m
An example to calculate Bn in 1D
- operate_3d.m
An example to calculate Bn in 3D
# draw Figure 2b
- operate_B3_3d.m
Calulate B3 from Matlab functions and draw inset of Figure 2b
- operate_B4_3d.m
Use data in /data_B4 (first two terms are from Matlab functions, and the third term is from MC integration) and draw Figure 2b in bi-symmetric logarithmic axes
- symlog.m
Functions to draw bi-symmetric logarithmic axes from online (see detailed information in this file)
-> Bi_combine.eps
