function b3 = third_virial(coeffs)
%third virial coefficient
%  coeffs=[\sigma,\lambda0,\lambda1,f0,f1]
    sigma = coeffs(1);
    r0 = coeffs(2);
    r1 = coeffs(3);
    f0 = coeffs(4);
    f1 = coeffs(5);
    
    %c: coefficients; a:integrals
    c0 = -2/3*sqrt(2*pi)*sigma^2;
    
    c1 = -(1+f0)^3 + r0^2*(f0-f1)^3 + r1^2*f1^3;
    a1 = 3*2^(-3/2)/sqrt(pi);
    
    c2 = -3*(1+f0)*(f0-f1)^2*r0;
    a2 = -2^(-3/2)/(r0*sqrt(pi))+sqrt(2/pi);
    
    c3 = -3*(1+f0)*f1^2*r1;
    a3 = -2^(-3/2)/(r1*sqrt(pi))+sqrt(2/pi);
    
    c4 = 3*(1+f0)^2*(f0-f1)*sqrt(r0);
    if r0<=2
        a4 = -(r0/2)^(3/2)/sqrt(pi)+sqrt(2*r0/pi);
    else
        a4 = sqrt(2/(r0*pi));
    end
    
    c5 = 3*(1+f0)^2*f1*sqrt(r1);
    a5 = sqrt(2/(r1*pi));
    
    c6 = 3*(f0-f1)^2*f1*r0*sqrt(r1);
    if r1 <= 2*r0
        a6 = -(r1/2)^(3/2)/(r0*sqrt(pi)) + sqrt(2*r1/pi);
    else
        a6 = r0*sqrt(2/(r1*pi));
    end
    
    c7 = 3*(f0-f1)*f1^2*sqrt(r0)*r1;
    a7 = -(r0/2)^(3/2)/(r1*sqrt(pi))+sqrt(2*r0/pi);
    
    c8 = -3*(1+f0)*(f0-f1)*f1*sqrt(r0*r1);
    a8 = sqrt(2*r0/(r1*pi));
    
    b3 = c0*(c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6+c7*a7+c8*a8);

end

