function b3 = third_virial_d(coeffs, d)
%third virial coefficient
%  d - dimensionality, coeffs=[\sigma,\lambda0,\lambda1,f0,f1]
    sigma = coeffs(1);
    r0 = coeffs(2);
    r1 = coeffs(3);
    f0 = coeffs(4);
    f1 = coeffs(5);
    
    %ci: coefficients; ai:integrals
    c = 2 * pi^(d/2) / gamma(d/2);
    c0 = -c/3 * (2*pi)^(d/2) * sigma^(2*d);
    
    c1 = -(1+f0)^3 + r0^(2*d)*(f0-f1)^3 + r1^(2*d)*f1^3;
    a1 = 3 * 2^(-d/2-1) / (d*sqrt(pi)*gamma(d/2+1/2)) * ...
        (beta(1/2,d/2+1/2)-hypergeom([1/2,1/2-d/2],3/2,1/4));
    
    c2 = -3*(1+f0)*(f0-f1)^2*r0^d;
    a2 = -2^(-d/2-1)/(r0*sqrt(pi) * gamma(3/2+d/2)) * ...
        hypergeom([1/2-d/2,1/2,1/2+d/2],[3/2,3/2+d/2],1/(4*r0^2)) + ...
        2^(-d/2+1)/(d^2*gamma(d/2));
    
    c3 = -3*(1+f0)*f1^2*r1^d;
    a3 = -2^(-d/2-1)/(r1*sqrt(pi)*gamma(3/2+d/2)) * ...
        hypergeom([1/2-d/2,1/2,1/2+d/2],[3/2,3/2+d/2],1/(4*r1^2)) + ...
        2^(-d/2+1)/(d^2*gamma(d/2));
    
    c4 = 3*(1+f0)^2*(f0-f1)*r0^(d/2);
    if r0<=2
        a4 = -2^(-d/2-1)*r0^(d/2+1)/(sqrt(pi)*gamma(3/2+d/2)) * ...
            hypergeom([1/2-d/2,1/2,1/2+d/2],[3/2,3/2+d/2],r0^2/4) + ...
            2^(-d/2+1)*r0^(d/2)/(d^2*gamma(d/2));
    else
        a4 = 2^(-d/2+1)*r0^(-d/2)/(d^2*gamma(d/2));
    end
    
    c5 = 3*(1+f0)^2*f1*r1^(d/2);
    a5 = 2^(-d/2+1)*r1^(-d/2)/(d^2*gamma(d/2));
    
    c6 = 3*(f0-f1)^2*f1 * r0^d * r1^(d/2);
    if r1 <= 2*r0
        a6 = -2^(-d/2-1)*r1^(d/2+1)/(r0*sqrt(pi)*gamma(3/2+d/2)) * ...
            hypergeom([1/2-d/2,1/2,1/2+d/2],[3/2,3/2+d/2],r1^2/(4*r0^2)) + ...
            2^(-d/2+1)*r1^(d/2)/(d^2*gamma(d/2));
    else
        a6 = 2^(-d/2+1) * r0^d * r1^(-d/2) / (d^2*gamma(d/2));
    end
    
    c7 = 3*(f0-f1)*f1^2 * r0^(d/2) * r1^d;
    a7 = -2^(-d/2-1)*r0^(d/2+1)/(r1*sqrt(pi)*gamma(3/2+d/2)) * ...
        hypergeom([1/2-d/2,1/2,1/2+d/2],[3/2,3/2+d/2],r0^2/(4*r1^2)) + ...
        2^(-d/2+1)*r0^(d/2)/(d^2*gamma(d/2));
    
    c8 = -3*(1+f0)*(f0-f1)*f1*r0^(d/2)*r1^(d/2);
    a8 = (r0/r1)^(d/2) * 2^(-d/2+1)/(d^2*gamma(d/2));
    
    b3 = c0*(c1*a1+c2*a2+c3*a3+c4*a4+c5*a5+c6*a6+c7*a7+c8*a8);
    
end

