(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    119532,       3004]
NotebookOptionsPosition[    117647,       2968]
NotebookOutlinePosition[    117991,       2983]
CellTagsIndexPosition[    117948,       2980]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "/", "Pi"}], ")"}], "^", "3"}], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"a1", "*", "x"}], "]"}], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"a2", "*", "y"}], "]"}], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"a3", "*", "z"}], "]"}], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"a4", "*", 
        RowBox[{"Abs", "[", 
         RowBox[{"x", "-", "y"}], "]"}]}], "]"}], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"a5", "*", 
        RowBox[{"Abs", "[", 
         RowBox[{"y", "-", "z"}], "]"}]}], "]"}], "*", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"a6", "*", 
         RowBox[{"Abs", "[", 
          RowBox[{"x", "-", "z"}], "]"}]}], "]"}], "/", 
       RowBox[{"(", 
        RowBox[{
        "a1", "*", "x", "*", "a2", "*", "y", "*", "a3", "*", "z", "*", "a4", 
         "*", 
         RowBox[{"Abs", "[", 
          RowBox[{"x", "-", "y"}], "]"}], "*", "a5", "*", 
         RowBox[{"Abs", "[", 
          RowBox[{"y", "-", "z"}], "]"}], "*", "a6", "*", 
         RowBox[{"Abs", "[", 
          RowBox[{"x", "-", "z"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"a1", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a2", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a3", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a4", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a5", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a6", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2.5", ",", "4"}], "}"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7709159409934278`*^9, 3.770915955557438*^9}, 
   3.7737067951627345`*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"2794b071-0f46-4f89-bb50-4ca358c9afde"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","slwcon",
   "\"Numerical integration converging too slowly; suspect one of the \
following: singularity, value of the integration is 0, highly oscillatory \
integrand, or WorkingPrecision too small.\"",2,7,21,21697313408023944216,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.773706813343294*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"e4942583-b799-49f4-862e-857b0fd6a9c3"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","eincr",
   "\"The global error of the strategy GlobalAdaptive has increased more than \
\\!\\(\\*RowBox[{\\\"2000\\\"}]\\) times. The global error is expected to \
decrease monotonically after a number of integrand evaluations. Suspect one \
of the following: the working precision is insufficient for the specified \
precision goal; the integrand is highly oscillatory or it is not a \
(piecewise) smooth function; or the true value of the integral is 0. \
Increasing the value of the GlobalAdaptive option MaxErrorIncreases might \
lead to a convergent numerical integration. NIntegrate obtained \
\\!\\(\\*RowBox[{\\\"0.9996919099832228`\\\"}]\\) and \
\\!\\(\\*RowBox[{\\\"0.00043969706258690844`\\\"}]\\) for the integral and \
error estimates.\"",2,7,22,21697313408023944216,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.7737068152058425`*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"a6d1dfc9-0b95-4c8d-a460-b93a8d858fb1"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","slwcon",
   "\"Numerical integration converging too slowly; suspect one of the \
following: singularity, value of the integration is 0, highly oscillatory \
integrand, or WorkingPrecision too small.\"",2,7,23,21697313408023944216,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.7737068158308477`*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"b2b1a53b-30dc-4bd3-809e-05024aea3b37"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","eincr",
   "\"The global error of the strategy GlobalAdaptive has increased more than \
\\!\\(\\*RowBox[{\\\"2000\\\"}]\\) times. The global error is expected to \
decrease monotonically after a number of integrand evaluations. Suspect one \
of the following: the working precision is insufficient for the specified \
precision goal; the integrand is highly oscillatory or it is not a \
(piecewise) smooth function; or the true value of the integral is 0. \
Increasing the value of the GlobalAdaptive option MaxErrorIncreases might \
lead to a convergent numerical integration. NIntegrate obtained \
\\!\\(\\*RowBox[{\\\"0.591330192391648`\\\"}]\\) and \
\\!\\(\\*RowBox[{\\\"0.00027782472377271876`\\\"}]\\) for the integral and \
error estimates.\"",2,7,24,21697313408023944216,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.773706817236767*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"bba40c78-fda9-44bc-bf3d-3d33fd7dc9a2"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","slwcon",
   "\"Numerical integration converging too slowly; suspect one of the \
following: singularity, value of the integration is 0, highly oscillatory \
integrand, or WorkingPrecision too small.\"",2,7,25,21697313408023944216,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.773706817705406*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"c45cde53-9730-411f-b147-a8f85c7ec50d"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"NIntegrate\\\", \
\\\"::\\\", \\\"slwcon\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,7,26,21697313408023944216,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.7737068177522707`*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"00c617c3-5843-4206-9d22-004894bc1f8d"],

Cell[BoxData[
 TemplateBox[{
  "NIntegrate","eincr",
   "\"The global error of the strategy GlobalAdaptive has increased more than \
\\!\\(\\*RowBox[{\\\"2000\\\"}]\\) times. The global error is expected to \
decrease monotonically after a number of integrand evaluations. Suspect one \
of the following: the working precision is insufficient for the specified \
precision goal; the integrand is highly oscillatory or it is not a \
(piecewise) smooth function; or the true value of the integral is 0. \
Increasing the value of the GlobalAdaptive option MaxErrorIncreases might \
lead to a convergent numerical integration. NIntegrate obtained \
\\!\\(\\*RowBox[{\\\"0.38318334073553706`\\\"}]\\) and \
\\!\\(\\*RowBox[{\\\"0.00031160449022694594`\\\"}]\\) for the integral and \
error estimates.\"",2,7,27,21697313408023944216,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.773706819595586*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"e5b9111c-eb61-43f8-8338-d98564b83c6c"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"NIntegrate\\\", \
\\\"::\\\", \\\"eincr\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,7,28,21697313408023944216,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7709159591723223`*^9, 3.7737068196580715`*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"ec25f337-b78d-42e0-8277-dee5cacbad4c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.9996919099832228`", ",", "0.591330192391648`", ",", 
             "0.38318334073553706`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.5913301923916486`", ",", "0.3847863688110605`", ",", 
             "0.25148206753952723`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.38318342512338954`", ",", "0.25150293397150253`", ",", 
             "0.16712457058638902`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.5913301923916489`", ",", "0.38484059567495826`", ",", 
             "0.2515024071442472`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.3847863688110604`", ",", "0.3112791422571365`", ",", 
             "0.2182398850412966`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.25150293397150253`", ",", "0.21823585401638418`", ",", 
             "0.1628570390320845`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.3831833407355367`", ",", "0.25150240714424726`", ",", 
             "0.16716257087638006`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.2514820675395271`", ",", "0.21823988504129654`", ",", 
             "0.16291040967550469`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.16712457058638877`", ",", "0.16285703903208432`", ",", 
             "0.14165054591654438`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.3420506953030537`", ",", "0.21578874638838733`", ",", 
             "0.1553463702078826`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.21580297116551897`", ",", "0.1476469390831084`", ",", 
             "0.10701033348468941`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.15533995124588912`", ",", "0.10701931796645757`", ",", 
             "0.07747868798696608`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.21331477209503458`", ",", "0.1529168498865662`", ",", 
             "0.10777015456206264`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.15290043918729757`", ",", "0.1284864794086013`", ",", 
             "0.09472113679236066`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1077622932184359`", ",", "0.09471812462437444`", ",", 
             "0.0726939460897853`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.1405509415909892`", ",", "0.10592818915250901`", ",", 
             "0.07840117001734764`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1059428904105493`", ",", "0.09401563920594774`", ",", 
             "0.07376590812019419`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07838424625530929`", ",", "0.07376416317199044`", ",", 
             "0.06401330014584411`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.20019279461433917`", ",", "0.10701196099605693`", ",", 
             "0.07801898966035002`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10701161180418443`", ",", "0.06364328301537268`", ",", 
             "0.04825915258981707`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07801721564264491`", ",", "0.048262453150616516`", ",", 
             "0.03632033933777959`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.1261189026678804`", ",", "0.07719437616652682`", ",", 
             "0.050738863225459785`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07718382332834314`", ",", "0.06377210767034153`", ",", 
             "0.04621990031707607`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05074017400072074`", ",", "0.04621153689055972`", ",", 
             "0.03566456430877665`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08332404460732473`", ",", "0.05482154275537175`", ",", 
             "0.038593774890301615`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05480873425085294`", ",", "0.04956085087791172`", ",", 
             "0.03828052670290436`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.038594070053342214`", ",", "0.03827814871786546`", ",", 
             "0.033826368095353394`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.3420506953030535`", ",", "0.2133147720950344`", ",", 
             "0.14055094159098924`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.21580297116551903`", ",", "0.1529004391872978`", ",", 
             "0.10594289041054927`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1553399512458889`", ",", "0.10776229321843574`", ",", 
             "0.07838424625530922`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.2157887463883874`", ",", "0.15291684988656623`", ",", 
             "0.1059281891525091`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1476469390831082`", ",", "0.12848647940860128`", ",", 
             "0.09401563920594777`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10701931796645749`", ",", "0.0947181246243745`", ",", 
             "0.0737641631719904`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.15534637020788233`", ",", "0.10777015456206271`", ",", 
             "0.07840117001734768`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10701033348468944`", ",", "0.09472113679236056`", ",", 
             "0.07376590812019423`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07747868798696618`", ",", "0.0726939460897853`", ",", 
             "0.06401330014584415`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.14360050981656497`", ",", "0.1017399789108083`", ",", 
             "0.07352036359885447`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.17355821671302904`", ",", "0.11116063421398387`", ",", 
             "0.07850003070920038`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1432740388186683`", ",", "0.0934515315881779`", ",", 
             "0.0660154017837226`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.10173997891080833`", ",", "0.10240300991587307`", ",", 
             "0.07925870516895578`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1111606342139839`", ",", "0.09353402463647414`", ",", 
             "0.07024552599793135`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.09345153158817801`", ",", "0.0804578707386014`", ",", 
             "0.060414383998135264`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07352036359885447`", ",", "0.07925870516895576`", ",", 
             "0.06691441080470874`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07850003070920035`", ",", "0.07024552599793132`", ",", 
             "0.05941974742536276`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06601540178372267`", ",", "0.06041438399813525`", ",", 
             "0.05151642249562738`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08605457271966876`", ",", "0.05223579141469137`", ",", 
             "0.038852060955164885`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.09265284285920042`", ",", "0.056165515908655685`", ",", 
             "0.04109304588546883`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07836848616701785`", ",", "0.049845998748843476`", ",", 
             "0.03616267735834983`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.061680297464340034`", ",", "0.05405383519102704`", ",", 
             "0.04125488435572257`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06039101901742602`", ",", "0.05048650014239971`", ",", 
             "0.03813787279936608`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05168737992990691`", ",", "0.04511915392387382`", ",", 
             "0.03413426208257511`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.044654884279039665`", ",", "0.04333073820704642`", ",", 
             "0.03681945428378748`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.042957222904872736`", ",", "0.03967248478066392`", ",", 
             "0.03406796332161136`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0370155937291633`", ",", "0.03497824494939878`", ",", 
             "0.030312254418653827`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.20019279461433906`", ",", "0.12611890266788034`", ",", 
             "0.08332404460732479`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10701161180418436`", ",", "0.07718382332834314`", ",", 
             "0.054808734250852933`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07801721564264487`", ",", "0.05074017400072071`", ",", 
             "0.038594070053342144`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.10701196099605699`", ",", "0.07719437616652688`", ",", 
             "0.054821542755371745`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06364328301537267`", ",", "0.06377210767034164`", ",", 
             "0.04956085087791168`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04826245315061648`", ",", "0.046211536890559686`", ",", 
             "0.038278148717865404`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07801898966035`", ",", "0.050738863225459716`", ",", 
             "0.03859377489030163`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.048259152589816966`", ",", "0.046219900317076075`", ",", 
             "0.03828052670290436`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0363203393377796`", ",", "0.03566456430877667`", ",", 
             "0.033826368095353394`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08605457271966865`", ",", "0.061680297464340075`", ",", 
             "0.04465488427903965`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.09265284285920053`", ",", "0.06039101901742602`", ",", 
             "0.042957222904872715`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07836848616701785`", ",", "0.051687379929906935`", ",", 
             "0.037015593729163306`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.05223579141469142`", ",", "0.05405383519102703`", ",", 
             "0.04333073820704646`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.056165515908655726`", ",", "0.05048650014239972`", ",", 
             "0.03967248478066392`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0498459987488435`", ",", "0.04511915392387383`", ",", 
             "0.034978244949398794`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.038852060955164844`", ",", "0.04125488435572265`", ",", 
             "0.03681945428378748`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04109304588546889`", ",", "0.038137872799366104`", ",", 
             "0.03406796332161135`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.036162677358349805`", ",", "0.03413426208257513`", ",", 
             "0.03031225441865381`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.05184550116177507`", ",", "0.03204008993571481`", ",", 
             "0.023897477772311455`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05536198679730137`", ",", "0.03574573977688318`", ",", 
             "0.025918676484424315`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06737272095823305`", ",", "0.04192754656343271`", ",", 
             "0.029508074721902346`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.032040089935714784`", ",", "0.030574117287458995`", ",", 
             "0.025546310302574305`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.035745739776883216`", ",", "0.03492933787808462`", ",", 
             "0.027709861798660515`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.041927546563432706`", ",", "0.03637996967920816`", ",", 
             "0.027637618240511697`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.023897477772311458`", ",", "0.02554631030257434`", ",", 
             "0.027344577604078487`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02591867648442432`", ",", "0.02770986179866052`", ",", 
             "0.026319310078274684`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02950807472190234`", ",", "0.027637618240511683`", ",", 
             "0.024677654294316485`"}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.342043719621081`", ",", "0.2157626048183192`", ",", 
             "0.15533755572351438`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.21337292739996164`", ",", "0.15291525523073923`", ",", 
             "0.10776137649266436`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.14055008972453872`", ",", "0.10592673194453633`", ",", 
             "0.07838266201968232`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.21576260481831927`", ",", "0.1476603668529026`", ",", 
             "0.10702016596772942`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.15291525523073934`", ",", "0.12848648290217354`", ",", 
             "0.09472117920648858`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.1059267319445363`", ",", "0.0940139578540146`", ",", 
             "0.07376808047184308`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.15533755572351432`", ",", "0.1070201659677296`", ",", 
             "0.07747902141440349`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10776137649266436`", ",", "0.09472117920648858`", ",", 
             "0.0726939460897853`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07838266201968232`", ",", "0.07376808047184308`", ",", 
             "0.06401331873019803`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.1436010256667926`", ",", "0.17354814494996285`", ",", 
             "0.14327415024191492`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10174791395431937`", ",", "0.11115959716187883`", ",", 
             "0.09345337978011407`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07351804407518983`", ",", "0.07850530063001475`", ",", 
             "0.0660129951012429`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.10174117055713684`", ",", "0.11116081134829411`", ",", 
             "0.09345872025090866`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10240907871768043`", ",", "0.09353464794284626`", ",", 
             "0.08047970016435699`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0792742175888939`", ",", "0.0702490755509875`", ",", 
             "0.06042305644918671`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07351848771486448`", ",", "0.07850483097462059`", ",", 
             "0.06601299814802962`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07927514801374314`", ",", "0.07024919703772524`", ",", 
             "0.06042306164361187`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06691418732765761`", ",", "0.05942033182971107`", ",", 
             "0.05151524366653331`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08611103507859567`", ",", "0.09258892820792221`", ",", 
             "0.07836812502717654`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05223424333381825`", ",", "0.056170720657433566`", ",", 
             "0.04984505392234204`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03885304002517037`", ",", "0.041091722229264424`", ",", 
             "0.03616346159241167`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.06167022382622187`", ",", "0.06038607571411479`", ",", 
             "0.051687781916806216`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05406251607879522`", ",", "0.050491789630662996`", ",", 
             "0.04510586336040527`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04125462028094348`", ",", "0.03813486134579252`", ",", 
             "0.034134737658843`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.04465256065450783`", ",", "0.04295833207593714`", ",", 
             "0.037018152195731124`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04332573764330428`", ",", "0.03967248478066395`", ",", 
             "0.034978965372224544`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03682081852350263`", ",", "0.034067423780461285`", ",", 
             "0.030312255031847327`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.14360102566679273`", ",", "0.10174117055713681`", ",", 
             "0.07351848771486462`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.10174791395431942`", ",", "0.10240907871768051`", ",", 
             "0.07927514801374312`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07351804407518986`", ",", "0.07927421758889396`", ",", 
             "0.06691418732765755`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.1735481449499631`", ",", "0.11116081134829414`", ",", 
             "0.07850483097462059`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.11115959716187887`", ",", "0.09353464794284627`", ",", 
             "0.07024919703772521`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07850530063001478`", ",", "0.07024907555098757`", ",", 
             "0.05942033182971107`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.14327415024191484`", ",", "0.09345872025090862`", ",", 
             "0.06601299814802972`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0934533797801141`", ",", "0.08047970016435704`", ",", 
             "0.0604230616436119`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06601299510124296`", ",", "0.060423056449186704`", ",", 
             "0.05151524366653334`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.069133282902383`", ",", "0.07586818608732962`", ",", 
             "0.06252999338328505`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07586822792965084`", ",", "0.07286844520008172`", ",", 
             "0.05982305152850838`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06253027603120515`", ",", "0.059821627409574835`", ",", 
             "0.04947729073724468`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07586818608732963`", ",", "0.07286838268121587`", ",", 
             "0.059822040911295234`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07286844520008177`", ",", "0.06400260341950773`", ",", 
             "0.05312636181836766`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05982162740957482`", ",", "0.05311305111038491`", ",", 
             "0.04480783304067202`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.06252999338328506`", ",", "0.059822040911295254`", ",", 
             "0.04947979532903949`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.059823051528508364`", ",", "0.053126361818367725`", ",", 
             "0.04480756188585206`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04947729073724473`", ",", "0.044807833040672006`", ",", 
             "0.03844905534601883`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.042308500986465394`", ",", "0.04365192558728607`", ",", 
             "0.03839452525590187`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04365012834121689`", ",", "0.04754836318832295`", ",", 
             "0.040240580210530036`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03839509797358965`", ",", "0.04024085871022921`", ",", 
             "0.03379468831686205`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.045895345697591974`", ",", "0.041291960486689816`", ",", 
             "0.03882162863995833`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04129258104293057`", ",", "0.039368571480300374`", ",", 
             "0.03525258990254276`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.038822910343672426`", ",", "0.03525294797188724`", ",", 
             "0.03094913164781171`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.03786818448552787`", ",", "0.03398970515083428`", ",", 
             "0.031927847384109434`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03398987599595636`", ",", "0.032801707931136875`", ",", 
             "0.029634628955500685`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03192690395093042`", ",", "0.029633768888064734`", ",", 
             "0.026353269746146366`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08611103507859576`", ",", "0.0616702238262219`", ",", 
             "0.044652560654507845`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05223424333381837`", ",", "0.05406251607879519`", ",", 
             "0.04332573764330429`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.038853040025170364`", ",", "0.04125462028094349`", ",", 
             "0.03682081852350266`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.09258892820792224`", ",", "0.06038607571411482`", ",", 
             "0.042958332075937154`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05617072065743355`", ",", "0.05049178963066301`", ",", 
             "0.03967248478066393`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04109172222926443`", ",", "0.03813486134579256`", ",", 
             "0.034067423780461285`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07836812502717648`", ",", "0.051687781916806244`", ",", 
             "0.03701815219573109`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.049845053922342`", ",", "0.04510586336040532`", ",", 
             "0.03497896537222455`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.036163461592411655`", ",", "0.03413473765884294`", ",", 
             "0.030312255031847306`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.042308500986465394`", ",", "0.04589534569759198`", ",", 
             "0.037868184485527874`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.043650128341216864`", ",", "0.04129258104293055`", ",", 
             "0.033989875995956376`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.038395097973589656`", ",", "0.03882291034367244`", ",", 
             "0.03192690395093042`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.043651925587286144`", ",", "0.04129196048668984`", ",", 
             "0.03398970515083426`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04754836318832298`", ",", "0.03936857148030033`", ",", 
             "0.03280170793113688`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.040240858710229206`", ",", "0.03525294797188726`", ",", 
             "0.029633768888064713`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.038394525255901917`", ",", "0.038821628639958305`", ",", 
             "0.0319278473841094`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04024058021053006`", ",", "0.03525258990254278`", ",", 
             "0.029634628955500664`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03379468831686203`", ",", "0.030949131647811705`", ",", 
             "0.026353269746146372`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.02597869394216791`", ",", "0.026674893914590752`", ",", 
             "0.023515274718140442`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.027613687838326836`", ",", "0.028887953508795142`", ",", 
             "0.02418851012845051`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03133181458592959`", ",", "0.030428404024932215`", ",", 
             "0.02472378989241474`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.026674893914590745`", ",", "0.02425631126266474`", ",", 
             "0.022959011744173672`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.028887953508795153`", ",", "0.02668802104981352`", ",", 
             "0.023553300943652638`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03042840402493221`", ",", "0.02676660683810254`", ",", 
             "0.022801833654875436`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.023515274718140463`", ",", "0.022959011744173682`", ",", 
             "0.022507526912706313`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.024188510128450514`", ",", "0.023553300943652624`", ",", 
             "0.021484853078033474`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.024723789892414756`", ",", "0.02280183365487542`", ",", 
             "0.020081050154791124`"}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.20019243619913854`", ",", "0.1070116097097608`", ",", 
             "0.07800902601844499`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.12611865265179756`", ",", "0.07718463737121295`", ",", 
             "0.05072147086196806`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.08332412929498446`", ",", "0.054810485033474694`", ",", 
             "0.03859198279044085`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.10701160970976074`", ",", "0.06366220236564721`", ",", 
             "0.04826220986755464`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.07718463737121292`", ",", "0.06377192669506788`", ",", 
             "0.046219900317076075`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.054810485033474646`", ",", "0.049563984920219975`", ",", 
             "0.03827593112594726`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.07800902601844482`", ",", "0.048262209867554626`", ",", 
             "0.03632157425451211`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05072147086196799`", ",", "0.04621990031707608`", ",", 
             "0.035640291479424796`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03859198279044085`", ",", "0.038275931125947245`", ",", 
             "0.033823316951862296`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08609937890619404`", ",", "0.09260302380452834`", ",", 
             "0.07837176647745062`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.061707374889901606`", ",", "0.06039148416432229`", ",", 
             "0.05168492352961574`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.044652837150876964`", ",", "0.04295777351932865`", ",", 
             "0.03701280481907936`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.05223564491646965`", ",", "0.05617641816446889`", ",", 
             "0.04984454129904688`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.054056896466160256`", ",", "0.05049178963066298`", ",", 
             "0.04510586336040537`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04332519983035481`", ",", "0.03967596249826227`", ",", 
             "0.0349789407157875`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.03885270804687431`", ",", "0.0410917571269872`", ",", 
             "0.03616131578655255`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.041252868157678965`", ",", "0.038135547661995395`", ",", 
             "0.03413008692373956`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03682040440079833`", ",", "0.03406773265351535`", ",", 
             "0.030311859737026357`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.051845392369327725`", ",", "0.05536231812497017`", ",", 
             "0.06737405648430797`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.032035516187403974`", ",", "0.03574501231441504`", ",", 
             "0.04191759201772604`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02389945951456277`", ",", "0.025923379354246795`", ",", 
             "0.02950863969504391`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.03203558716238708`", ",", "0.035749070331999935`", ",", 
             "0.041927561920576936`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.030570648365840336`", ",", "0.03492870124040965`", ",", 
             "0.03638060657708316`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02555803655419268`", ",", "0.02771412900663276`", ",", 
             "0.02763690053907868`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.023897934515248822`", ",", "0.025922492763821567`", ",", 
             "0.029509017054579943`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.025545645332437045`", ",", "0.02770986179866052`", ",", 
             "0.027636729105360757`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02734622099233563`", ",", "0.02631908766947868`", ",", 
             "0.024677639272001957`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.08609937890619407`", ",", "0.05223564491646968`", ",", 
             "0.03885270804687428`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06170737488990159`", ",", "0.0540568964661602`", ",", 
             "0.04125286815767896`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04465283715087691`", ",", "0.043325199830354794`", ",", 
             "0.036820404400798305`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.09260302380452831`", ",", "0.056176418164468854`", ",", 
             "0.0410917571269872`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.06039148416432229`", ",", "0.05049178963066301`", ",", 
             "0.03813554766199539`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04295777351932858`", ",", "0.039675962498262274`", ",", 
             "0.03406773265351534`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.0783717664774506`", ",", "0.049844541299046835`", ",", 
             "0.03616131578655258`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.05168492352961576`", ",", "0.04510586336040529`", ",", 
             "0.03413008692373948`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.037012804819079405`", ",", "0.03497894071578752`", ",", 
             "0.030311859737026336`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.04230850098646537`", ",", "0.04365192558728609`", ",", 
             "0.038394501466494355`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04589529262982789`", ",", "0.04130377314311952`", ",", 
             "0.038823765487793226`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03786822546631808`", ",", "0.03398979191831309`", ",", 
             "0.03192616322336434`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.04365192558728607`", ",", "0.047547745265869724`", ",", 
             "0.04024113085604598`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04130377314311956`", ",", "0.03936845559754592`", ",", 
             "0.035252589902542715`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03398979191831306`", ",", "0.03280180423128245`", ",", 
             "0.029633893422285375`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.038394501466494375`", ",", "0.04024113085604599`", ",", 
             "0.033778474602035966`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03882376548779321`", ",", "0.035252589902542736`", ",", 
             "0.030951447973135374`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.031926163223364314`", ",", "0.029633893422285375`", ",", 
             "0.02635265269058984`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.02597951355216781`", ",", "0.0276140141633502`", ",", 
             "0.031332168569555535`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02667554272512021`", ",", "0.028887960176308958`", ",", 
             "0.030429552067153906`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0235160098709158`", ",", "0.024188264785021837`", ",", 
             "0.02472401538424872`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.026687735385337297`", ",", "0.028883050690242235`", ",", 
             "0.03042867527690975`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.024256658308255283`", ",", "0.026688036460438373`", ",", 
             "0.026766387597647906`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.022961511718856704`", ",", "0.02355361633891285`", ",", 
             "0.022801129076232877`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.023516181579910443`", ",", "0.024189899248462408`", ",", 
             "0.02472252180093198`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02296064701904838`", ",", "0.023553300943652627`", ",", 
             "0.02279349504425007`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02250752691270632`", ",", "0.021484853078033467`", ",", 
             "0.02008100412291275`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.051845392369327725`", ",", "0.03203558716238713`", ",", 
             "0.023897934515248773`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.032035516187403905`", ",", "0.030570648365840305`", ",", 
             "0.025545645332437066`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.023899459514562783`", ",", "0.02555803655419266`", ",", 
             "0.027346220992335652`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.05536231812497018`", ",", "0.03574907033199995`", ",", 
             "0.025922492763821577`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.03574501231441499`", ",", "0.03492870124040959`", ",", 
             "0.027709861798660543`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.025923379354246764`", ",", "0.027714129006632754`", ",", 
             "0.02631908766947865`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.06737405648430796`", ",", "0.04192756192057695`", ",", 
             "0.02950901705457993`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.04191759201772606`", ",", "0.03638060657708315`", ",", 
             "0.027636729105360757`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.029508639695043946`", ",", "0.027636900539078687`", ",", 
             "0.024677639272001943`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.02597951355216779`", ",", "0.026687735385337284`", ",", 
             "0.023516181579910457`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0266755427251202`", ",", "0.024256658308255283`", ",", 
             "0.022960647019048368`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.0235160098709158`", ",", "0.022961511718856707`", ",", 
             "0.022507526912706344`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.027614014163350242`", ",", "0.02888305069024224`", ",", 
             "0.0241898992484624`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.028887960176308975`", ",", "0.026688036460438342`", ",", 
             "0.023553300943652634`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.02418826478502182`", ",", "0.023553616338912852`", ",", 
             "0.021484853078033456`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.03133216856955553`", ",", "0.03042867527690974`", ",", 
             "0.024722521800932012`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.030429552067153896`", ",", "0.02676638759764789`", ",", 
             "0.02279349504425007`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.024724015384248718`", ",", "0.0228011290762329`", ",", 
             "0.020081004122912742`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.016033524101850383`", ",", "0.017030372457239523`", ",", 
             "0.01913055159086585`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.01703037245723952`", ",", "0.01793985822050257`", ",", 
             "0.01836719235344193`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.019131741165640287`", ",", "0.018370258554108038`", ",", 
             "0.018287029199207803`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.01703037245723953`", ",", "0.01794233587707247`", ",", 
             "0.018367459923518414`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.01793985822050255`", ",", "0.019144585581701897`", ",", 
             "0.01819346603887997`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.018370258554108045`", ",", "0.01819339499622448`", ",", 
             "0.017028042699376134`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "0.01913055159086584`", ",", "0.018367459923518414`", ",", 
             "0.018287355666013087`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.018367192353441936`", ",", "0.01819346603887995`", ",", 
             "0.017022519287318332`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "0.018287029199207796`", ",", "0.017028042699376123`", ",", 
             "0.0156249714949674`"}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7709179741872606`*^9, 3.7737083760749216`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"2c3587de-3394-41c0-a95a-3d7bc59bc9a6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", " ", "=", " ", "0.2"}]], "Input",
 CellChangeTimes->{{3.7709214592306395`*^9, 3.7709214801280947`*^9}, {
  3.7737089233606024`*^9, 3.7737089262823277`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"a4158c1a-693b-4133-9e3a-421dc8ce465b"],

Cell[BoxData["0.2`"], "Output",
 CellChangeTimes->{3.770921482095211*^9, 3.773708928268244*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"8e3934d3-cb28-4b1d-974f-03b53544b990"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"a1", "*", "a2", "*", "a3", "*", "a4", "*", "a5", "*", "a6"}], ",", 
   RowBox[{"{", 
    RowBox[{"a1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a3", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a4", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a5", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a6", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Exp", "[", 
         RowBox[{"1", "/", "T"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"1", "/", "T"}], "]"}], "-", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}]}], ")"}], "*", "2.5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "T"}], "]"}], "-", "1"}], ")"}], "*", 
        "4"}]}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.770921535621482*^9, 3.770921711377651*^9}, {
  3.773708938689516*^9, 3.7737089990954733`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"5d5442a1-6462-4038-ab79-a544f026fa44"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.0686474581524459`*^13", ",", 
             RowBox[{"-", "2.671497354082262`*^13"}], ",", 
             "2.860789365679043`*^11"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.6714973540822625`*^13"}], ",", 
             "6.6784401707250664`*^13", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.860789365679043`*^11", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "7.658386994090253`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.6714973540822625`*^13"}], ",", 
             "6.6784401707250664`*^13", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.6695342425025978`*^14"}], ",", 
             "1.787831007689397`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893965`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.860789365679043`*^11", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "7.658386994090253`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893965`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215985`*^8"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.671497354082262`*^13"}], ",", 
             "6.678440170725065`*^13", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"6.678440170725066`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.678440170725066`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.17364611441313`*^14", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.46937460071805`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.46937460071805`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.860789365679043`*^11", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "7.658386994090253`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.6714973540822625`*^13"}], ",", 
             "6.678440170725066`*^13", ",", 
             RowBox[{"-", "7.15164871510694`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.1736461144131306`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.787831007689397`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.173646114413131`*^14", ",", 
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "1.1172929228562742`*^13"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050294`*^9"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.860789365679043`*^11", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "7.658386994090253`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050296`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"5.488329280514136`*^6", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "146923.60816713757`"}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "2.6714973540822625`*^13"}], ",", 
             "6.678440170725066`*^13", ",", 
             RowBox[{"-", "7.15164871510694`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.7878310076893967`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.1736461144131306`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.787831007689397`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.173646114413131`*^14", ",", 
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "1.1172929228562742`*^13"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050294`*^9"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6.6784401707250664`*^13", ",", 
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "1.787831007689397`*^12"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.669534242502598`*^14"}], ",", 
             "4.173646114413131`*^14", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.173646114413131`*^14", ",", 
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "1.1172929228562742`*^13"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050294`*^9"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.6695342425025978`*^14"}], ",", 
             "4.17364611441313`*^14", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.1736461144131306`*^14", ",", 
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "1.117292922856274`*^13"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.1736461144131306`*^14", ",", 
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "1.117292922856274`*^13"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0433641577931708`*^15"}], ",", 
             "2.608291972834225`*^15", ",", 
             RowBox[{"-", "2.793105494590131`*^13"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.117292922856274`*^13", ",", 
             RowBox[{"-", "2.79310549459013`*^13"}], ",", 
             "2.991014190574826`*^11"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.117292922856274`*^13", ",", 
             RowBox[{"-", "2.79310549459013`*^13"}], ",", 
             "2.991014190574826`*^11"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.1172929228562742`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050296`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.1172929228562742`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.1172929228562742`*^13", ",", 
             RowBox[{"-", "2.793105494590131`*^13"}], ",", 
             "2.9910141905748267`*^11"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050296`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050296`*^9", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}], ",", 
             "3.429894345186705`*^7"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893965`*^12", ",", 
             RowBox[{"-", "4.46937460071805`*^12"}], ",", 
             "4.78605726838257`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.78605726838257`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.117292922856274`*^13", ",", 
             RowBox[{"-", "2.79310549459013`*^13"}], ",", 
             "2.991014190574826`*^11"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "2.9910141905748254`*^11", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.78605726838257`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "2.9910141905748254`*^11", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "3.4298943451867044`*^7", ",", 
             RowBox[{"-", "367292.3446141158`"}]}], "}"}]}], "}"}]}], "}"}]}],
       "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.860789365679043`*^11", ",", 
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "7.658386994090253`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.15164871510694`*^11"}], ",", 
             "1.787831007689397`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.787831007689397`*^12", ",", 
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "4.7860572683825714`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.78605726838257`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050296`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"5.488329280514136`*^6", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "146923.60816713757`"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7.151648715106938`*^11"}], ",", 
             "1.7878310076893967`*^12", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893967`*^12", ",", 
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "4.786057268382571`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718052`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1.7878310076893965`*^12", ",", 
             RowBox[{"-", "4.46937460071805`*^12"}], ",", 
             "4.78605726838257`*^10"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.78605726838257`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "4.469374600718051`*^12"}], ",", 
             "1.117292922856274`*^13", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.117292922856274`*^13", ",", 
             RowBox[{"-", "2.79310549459013`*^13"}], ",", 
             "2.991014190574826`*^11"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "2.9910141905748254`*^11", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.78605726838257`*^10", ",", 
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296866`*^11"}], ",", 
             "2.9910141905748254`*^11", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "3.4298943451867044`*^7", ",", 
             RowBox[{"-", "367292.3446141158`"}]}], "}"}]}], "}"}]}], "}"}]}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"7.658386994090253`*^9", ",", 
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "2.0501646173215988`*^8"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.7860572683825714`*^10", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.7860572683825714`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050296`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.0501646173215988`*^8", ",", 
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"5.488329280514136`*^6", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "146923.60816713757`"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.914509825964657`*^10"}], ",", 
             "4.786057268382571`*^10", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4.786057268382571`*^10", ",", 
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "1.2812365418050292`*^9"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1964599954296867`*^11"}], ",", 
             "2.991014190574826`*^11", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "1.2812365418050292`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050292`*^9", ",", 
             RowBox[{"-", "3.202945934390055`*^9"}], ",", 
             "3.4298943451867044`*^7"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "3.4298943451867044`*^7", ",", 
             RowBox[{"-", "367292.3446141158`"}]}], "}"}]}], "}"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2.0501646173215985`*^8", ",", 
             RowBox[{"-", "5.1251788499799263`*^8"}], ",", 
             "5.488329280514136`*^6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050294`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"5.488329280514136`*^6", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "146923.60816713757`"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5.125178849979927`*^8"}], ",", 
             "1.2812365418050294`*^9", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1.2812365418050294`*^9", ",", 
             RowBox[{"-", "3.2029459343900557`*^9"}], ",", 
             "3.429894345186705`*^7"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "3.4298943451867044`*^7", ",", 
             RowBox[{"-", "367292.3446141158`"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"5.488329280514136`*^6", ",", 
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "146923.60816713757`"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.3720200276875718`*^7"}], ",", 
             "3.4298943451867044`*^7", ",", 
             RowBox[{"-", "367292.3446141158`"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"146923.60816713757`", ",", 
             RowBox[{"-", "367292.3446141158`"}], ",", "3933.172653013339`"}],
             "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.770921718895279*^9, 3.773709002736458*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"f6f3043e-3842-4ddc-ae57-350c5f65e5f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Total", "[", 
   RowBox[{
    RowBox[{"%7", "*", "%9"}], ",", " ", "Infinity"}], "]"}], "*", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "8"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.770922379564867*^9, 3.7709223840956097`*^9}, {
  3.77092247378352*^9, 3.77092247543326*^9}, {3.7737090397198563`*^9, 
  3.773709095768025*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"6c4f18a3-857c-4b72-8bab-0168c1290b09"],

Cell[BoxData["2.8785967261806097`*^9"], "Output",
 CellChangeTimes->{3.7737090974234753`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"fe68b2bb-47f4-4658-b4f8-3ccd0777dc2d"]
}, Open  ]]
},
WindowSize->{1118, 833},
WindowMargins->{{Automatic, 213}, {64, Automatic}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 2487, 70, 67, "Input",ExpressionUUID->"2794b071-0f46-4f89-bb50-4ca358c9afde"],
Cell[3070, 94, 499, 11, 21, "Message",ExpressionUUID->"e4942583-b799-49f4-862e-857b0fd6a9c3"],
Cell[3572, 107, 1048, 18, 74, "Message",ExpressionUUID->"a6d1dfc9-0b95-4c8d-a460-b93a8d858fb1"],
Cell[4623, 127, 501, 11, 21, "Message",ExpressionUUID->"b2b1a53b-30dc-4bd3-809e-05024aea3b37"],
Cell[5127, 140, 1045, 18, 74, "Message",ExpressionUUID->"bba40c78-fda9-44bc-bf3d-3d33fd7dc9a2"],
Cell[6175, 160, 499, 11, 21, "Message",ExpressionUUID->"c45cde53-9730-411f-b147-a8f85c7ec50d"],
Cell[6677, 173, 474, 10, 21, "Message",ExpressionUUID->"00c617c3-5843-4206-9d22-004894bc1f8d"],
Cell[7154, 185, 1047, 18, 74, "Message",ExpressionUUID->"e5b9111c-eb61-43f8-8338-d98564b83c6c"],
Cell[8204, 205, 473, 10, 21, "Message",ExpressionUUID->"ec25f337-b78d-42e0-8277-dee5cacbad4c"],
Cell[8680, 217, 47319, 1219, 1610, "Output",ExpressionUUID->"2c3587de-3394-41c0-a95a-3d7bc59bc9a6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56036, 1441, 262, 4, 28, "Input",ExpressionUUID->"a4158c1a-693b-4133-9e3a-421dc8ce465b"],
Cell[56301, 1447, 173, 2, 32, "Output",ExpressionUUID->"8e3934d3-cb28-4b1d-974f-03b53544b990"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56511, 1454, 4314, 138, 86, "Input",ExpressionUUID->"5d5442a1-6462-4038-ab79-a544f026fa44"],
Cell[60828, 1594, 56135, 1351, 2267, "Output",ExpressionUUID->"f6f3043e-3842-4ddc-ae57-350c5f65e5f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117000, 2950, 456, 11, 28, "Input",ExpressionUUID->"6c4f18a3-857c-4b72-8bab-0168c1290b09"],
Cell[117459, 2963, 172, 2, 32, "Output",ExpressionUUID->"fe68b2bb-47f4-4658-b4f8-3ccd0777dc2d"]
}, Open  ]]
}
]
*)

